﻿using System;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Microsoft.Practices.ServiceLocation;

namespace ViewModelLocation.MVVM
{
    public class IndexerConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            var locator = value as ViewModelLocator;

            var viewType = GetViewType();

            var viewModelType = locator.GetViewModelTypeForView(viewType);

            var viewModelInstance = ServiceLocator.Current.GetInstance(viewModelType);

            return viewModelInstance;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        private Type GetViewType()
        {
            var stack = new StackTrace();

            return stack.GetFrames()
                .Select(f => f.GetMethod())
                .Where(m => m.Name == "InitializeComponent")
                .Select(m => m.DeclaringType)
                .FirstOrDefault();
        }
    }
}
